#include <owl\applicat.h>
#include <owl\decmdifr.h>
#include <owl\editfile.h>
#include <owl\mdi.h>
#include <owl\controlb.h>
#include <owl\statusba.h>
#include <owl\buttonga.h>
#include "pr73_1.rc"

// .
class TMDIApp: public TApplication
{
  public:
	 TMDIApp():TApplication(){}
	 void InitMainWindow();
  protected:
	  TMDIClient *clienTWndw;
	  TControlBar *controlBar;
	  TMDIChild *childWnd;
	  void CmFileOpen();

	  DECLARE_RESPONSE_TABLE (TMDIApp);
};

DEFINE_RESPONSE_TABLE1(TMDIApp, TApplication)
EV_COMMAND (CM_FILEOPEN, CmFileOpen),
END_RESPONSE_TABLE;

// TMDIApp::InitMainWindow()
//      ,
// -,   
//  .
void TMDIApp::InitMainWindow()
{  //  -.
  clienTWndw = new TMDIClient;
  //   .
  TDecoratedMDIFrame *frameWnd = new TDecoratedMDIFrame ("  ",
			 MENU_1, *clienTWndw, TRUE);
  //      .
  frameWnd->Attr.X = 50;
  frameWnd->Attr.Y = 50;
  frameWnd->Attr.W=GetSystemMetrics(SM_CXSCREEN)/3;
  frameWnd->Attr.H=GetSystemMetrics(SM_CXSCREEN)/3;
  //   .
  controlBar = new TControlBar (frameWnd,TControlBar::Vertical);
  controlBar->Insert(*new TButtonGadget(ID_OPEN, CM_FILEOPEN));
  controlBar->Insert(*new TSeparatorGadget (10));
  controlBar->Insert(*new TButtonGadget(ID_EXIT, CM_EXIT));
  controlBar->Insert(*new TSeparatorGadget (30));
  controlBar->Insert(*new TButtonGadget(ID_FIND, CM_EDITFIND));
  controlBar->Insert(*new TSeparatorGadget (10));
  controlBar->Insert(*new TButtonGadget(ID_FINDREPLACE, CM_EDITFINDNEXT));
  controlBar->Insert(*new TSeparatorGadget (10));
  controlBar->Insert(*new TButtonGadget(ID_REPLACE, CM_EDITREPLACE));
	//      .
  frameWnd->Insert(*controlBar, TDecoratedFrame::Right);
  //   ,  
  //  .
  controlBar->SetHintMode(TGadgetWindow::EnterHints);
  //   .
  TMessageBar *msgbar=new TMessageBar(0);
  //     .
  frameWnd->Insert(*msgbar, TDecoratedFrame::Bottom);
  EnableCtl3d (TRUE);
  //    MainWindow .
  SetMainWindow(frameWnd);
};

void TMDIApp::CmFileOpen()
{  //   TData  .
  TOpenSaveDialog::TData fileData (OFN_FILEMUSTEXIST |
	 OFN_HIDEREADONLY | OFN_PATHMUSTEXIST,
	 "  (*.*) | *.* |  (*.txt) | *.txt |", 0, 0, " * ");
  //      .
  strcpy(fileData.FileName, "");
  //    Open.
  TFileOpenDialog *dialog = new TFileOpenDialog (MainWindow, fileData);
  //    Open.
  int result = dialog->Execute();
  //      ...
  if (result == IDOK)
	 //      .
	{TEditFile *editFile =new TEditFile (0, 0, 0, 0, 0, 0, 0, fileData.FileName);
	 //      .
	 childWnd = new TMDIChild (*clienTWndw, "", editFile);
	 //    .
	 childWnd->Create();
	 }
};

int OwlMain(int,char *[])
{
  return TMDIApp().Run();
}